/**
 *  \file IMP/container/DynamicListPairContainer.h
 *  \brief Store a list of kernel::ParticlePairsTemp
 *
 *  WARNING This file was generated from DynamicListPairContainer.h
 *  in /builddir/build/BUILD/imp-2.3.0/imp/tools/build/container_templates/container
 *  by tools/build/make_containers.py.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_DYNAMIC_LIST_PAIR_CONTAINER_H
#define IMPCONTAINER_DYNAMIC_LIST_PAIR_CONTAINER_H

#include <IMP/container/container_config.h>
#include <IMP/base/object_macros.h>
#include <IMP/kernel/internal/DynamicListContainer.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Store a kernel::ParticleIndexPairs
/** In contrast to ListPairContainer, this list is designed to act
    as the output of a ScoreState or another container. The key difference
    is that it uses the passed Container to define the list of all
    possible contents of the container.
 */
class IMPCONTAINEREXPORT DynamicListPairContainer :
#if defined(IMP_DOXYGEN) || defined(SWIG)
    public PairContainer
#else
    public IMP::kernel::internal::DynamicListContainer<
        kernel::PairContainer>
#endif
    {
  typedef IMP::kernel::internal::DynamicListContainer<
      kernel::PairContainer> P;

 public:
  /** Constructs the dynamic list

      @param scope a container with a list of all possible particles that
                   are allowed to be dynamically added or removed in this
                   container
      @param name  the name of this container
  */
  DynamicListPairContainer(Container *scope, std::string name =
                                                  "ListPairContainer %1%");

  /** @name Methods to control the contained objects

      This container stores a list of Pair objects. To manipulate
      the list use these methods.
   */
  /**@{*/
  void add_particle_pair(const kernel::ParticlePair& vt);
  void add_particle_pairs(const kernel::ParticlePairsTemp &c);
  void set_particle_pairs(kernel::ParticlePairsTemp c);
  void clear_particle_pairs();
/**@}*/
#ifdef SWIG
  kernel::ParticleIndexPairs get_indexes() const;
  kernel::ParticleIndexPairs get_range_indexes() const;
  kernel::ModelObjectsTemp do_get_inputs() const;
  void do_apply(const PairModifier *sm) const;
  kernel::ParticleIndexes get_all_possible_indexes() const;
#endif
  IMP_OBJECT_METHODS(DynamicListPairContainer);
};

IMP_OBJECTS(DynamicListPairContainer, DynamicListPairContainers);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_DYNAMIC_LIST_PAIR_CONTAINER_H */
