/**
 *  \file IMP/container/DynamicListQuadContainer.h
 *  \brief Store a list of kernel::ParticleQuadsTemp
 *
 *  WARNING This file was generated from DynamicListQuadContainer.h
 *  in /builddir/build/BUILD/imp-2.3.0/imp/tools/build/container_templates/container
 *  by tools/build/make_containers.py.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_DYNAMIC_LIST_QUAD_CONTAINER_H
#define IMPCONTAINER_DYNAMIC_LIST_QUAD_CONTAINER_H

#include <IMP/container/container_config.h>
#include <IMP/base/object_macros.h>
#include <IMP/kernel/internal/DynamicListContainer.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Store a kernel::ParticleIndexQuads
/** In contrast to ListQuadContainer, this list is designed to act
    as the output of a ScoreState or another container. The key difference
    is that it uses the passed Container to define the list of all
    possible contents of the container.
 */
class IMPCONTAINEREXPORT DynamicListQuadContainer :
#if defined(IMP_DOXYGEN) || defined(SWIG)
    public QuadContainer
#else
    public IMP::kernel::internal::DynamicListContainer<
        kernel::QuadContainer>
#endif
    {
  typedef IMP::kernel::internal::DynamicListContainer<
      kernel::QuadContainer> P;

 public:
  /** Constructs the dynamic list

      @param scope a container with a list of all possible particles that
                   are allowed to be dynamically added or removed in this
                   container
      @param name  the name of this container
  */
  DynamicListQuadContainer(Container *scope, std::string name =
                                                  "ListQuadContainer %1%");

  /** @name Methods to control the contained objects

      This container stores a list of Quad objects. To manipulate
      the list use these methods.
   */
  /**@{*/
  void add_particle_quad(const kernel::ParticleQuad& vt);
  void add_particle_quads(const kernel::ParticleQuadsTemp &c);
  void set_particle_quads(kernel::ParticleQuadsTemp c);
  void clear_particle_quads();
/**@}*/
#ifdef SWIG
  kernel::ParticleIndexQuads get_indexes() const;
  kernel::ParticleIndexQuads get_range_indexes() const;
  kernel::ModelObjectsTemp do_get_inputs() const;
  void do_apply(const QuadModifier *sm) const;
  kernel::ParticleIndexes get_all_possible_indexes() const;
#endif
  IMP_OBJECT_METHODS(DynamicListQuadContainer);
};

IMP_OBJECTS(DynamicListQuadContainer, DynamicListQuadContainers);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_DYNAMIC_LIST_QUAD_CONTAINER_H */
