/**
 *  \file IMP/container/DynamicListTripletContainer.h
 *  \brief Store a list of kernel::ParticleTripletsTemp
 *
 *  WARNING This file was generated from DynamicListTripletContainer.h
 *  in /builddir/build/BUILD/imp-2.3.0/imp/tools/build/container_templates/container
 *  by tools/build/make_containers.py.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_DYNAMIC_LIST_TRIPLET_CONTAINER_H
#define IMPCONTAINER_DYNAMIC_LIST_TRIPLET_CONTAINER_H

#include <IMP/container/container_config.h>
#include <IMP/base/object_macros.h>
#include <IMP/kernel/internal/DynamicListContainer.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Store a kernel::ParticleIndexTriplets
/** In contrast to ListTripletContainer, this list is designed to act
    as the output of a ScoreState or another container. The key difference
    is that it uses the passed Container to define the list of all
    possible contents of the container.
 */
class IMPCONTAINEREXPORT DynamicListTripletContainer :
#if defined(IMP_DOXYGEN) || defined(SWIG)
    public TripletContainer
#else
    public IMP::kernel::internal::DynamicListContainer<
        kernel::TripletContainer>
#endif
    {
  typedef IMP::kernel::internal::DynamicListContainer<
      kernel::TripletContainer> P;

 public:
  /** Constructs the dynamic list

      @param scope a container with a list of all possible particles that
                   are allowed to be dynamically added or removed in this
                   container
      @param name  the name of this container
  */
  DynamicListTripletContainer(Container *scope, std::string name =
                                                  "ListTripletContainer %1%");

  /** @name Methods to control the contained objects

      This container stores a list of Triplet objects. To manipulate
      the list use these methods.
   */
  /**@{*/
  void add_particle_triplet(const kernel::ParticleTriplet& vt);
  void add_particle_triplets(const kernel::ParticleTripletsTemp &c);
  void set_particle_triplets(kernel::ParticleTripletsTemp c);
  void clear_particle_triplets();
/**@}*/
#ifdef SWIG
  kernel::ParticleIndexTriplets get_indexes() const;
  kernel::ParticleIndexTriplets get_range_indexes() const;
  kernel::ModelObjectsTemp do_get_inputs() const;
  void do_apply(const TripletModifier *sm) const;
  kernel::ParticleIndexes get_all_possible_indexes() const;
#endif
  IMP_OBJECT_METHODS(DynamicListTripletContainer);
};

IMP_OBJECTS(DynamicListTripletContainer, DynamicListTripletContainers);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_DYNAMIC_LIST_TRIPLET_CONTAINER_H */
