/**
 *  \file IMP/container/EventTripletsOptimizerState.h
 *  \brief Define some predicates.
 *
 *  WARNING This file was generated from EventTripletsOptimizerState.h
 *  in /builddir/build/BUILD/imp-2.3.0/imp/tools/build/container_templates/container
 *  by tools/build/make_containers.py.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_EVENT_TRIPLETS_OPTIMIZER_STATE_H
#define IMPCONTAINER_EVENT_TRIPLETS_OPTIMIZER_STATE_H

#include <IMP/container/container_config.h>
#include <IMP/TripletPredicate.h>
#include <IMP/OptimizerState.h>
#include <IMP/TripletContainer.h>

IMPCONTAINER_BEGIN_NAMESPACE

/** Raise an IMP::base::EventException when a certain condition is met.
    Currently the supported logic is when the number of items in the
    container for which the predicate returns a certain value is in the
    range [min_count, max_count).
 */
class IMPCONTAINEREXPORT EventTripletsOptimizerState : public OptimizerState {
  IMP::base::PointerMember<TripletPredicate> pred_;
  IMP::base::PointerMember<TripletContainer> container_;
  int v_;
  int min_, max_;

 public:
  EventTripletsOptimizerState(TripletPredicate *pred,
                                TripletContainerAdaptor container, int value,
                                int min_count, int max_count,
                                std::string name =
                                    "ConstTripletPredicate%1%");
  virtual void update() IMP_OVERRIDE;
  IMP_OBJECT_METHODS(EventTripletsOptimizerState);
};

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_EVENT_TRIPLETS_OPTIMIZER_STATE_H */
