/**
 *  \file IMP/container/ListPairContainer.h
 *  \brief Store a list of kernel::ParticlePairsTemp
 *
 *  WARNING This file was generated from ListPairContainer.h
 *  in /builddir/build/BUILD/imp-2.3.0/imp/tools/build/container_templates/container
 *  by tools/build/make_containers.py.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_LIST_PAIR_CONTAINER_H
#define IMPCONTAINER_LIST_PAIR_CONTAINER_H

#include <IMP/container/container_config.h>
#include <IMP/base/object_macros.h>
#include <IMP/kernel/internal/StaticListContainer.h>
#include <IMP/kernel/PairContainer.h>
#include <IMP/kernel/PairModifier.h>
#include <IMP/kernel/base_types.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Store a kernel::ParticleIndexPairs
/** \note The order may change when particles are inserted
    as the list is maintained in sorted order.

    \note Changing the contents of the container is a fairly heavy
    weight operation as it resets part of the dependency graph. Use
    a DynamicListPairContainer if you want to change the contents
    frequently (eg via a kernel::ScoreState).
 */
class IMPCONTAINEREXPORT ListPairContainer :
#if defined(IMP_DOXYGEN) || defined(SWIG)
    public PairContainer
#else
    public IMP::kernel::internal::StaticListContainer<
        kernel::PairContainer>
#endif
    {
  typedef IMP::kernel::internal::StaticListContainer<kernel::PairContainer>
      P;

 public:
  ListPairContainer(kernel::Model *m, const kernel::ParticleIndexPairs &contents,
                         std::string name = "ListPairContainer%1%");

  ListPairContainer(const kernel::ParticlePairsTemp &ps,
                         std::string name = "ListPairContainer%1%");

  void set_particle_pairs(const kernel::ParticlePairsTemp &ps);
  void set_particle_pairs(const kernel::ParticleIndexPairs &contents);
#ifndef IMP_DOXYGEN
  ListPairContainer(kernel::Model *m,
                         std::string name = "ListPairContainer %1%");
  ListPairContainer(kernel::Model *m, const char *name);

  void add_particle_pair(const kernel::ParticlePair& vt);
  void add_particle_pairs(const kernel::ParticlePairsTemp &c);
  void clear_particle_pairs();
#endif
#ifdef SWIG
  kernel::ParticleIndexPairs get_indexes() const;
  kernel::ParticleIndexPairs get_range_indexes() const;
  kernel::ModelObjectsTemp do_get_inputs() const;
  void do_apply(const PairModifier *sm) const;
  kernel::ParticleIndexes get_all_possible_indexes() const;

 private:
  std::size_t do_get_contents_hash() const;
#endif
  IMP_OBJECT_METHODS(ListPairContainer);
};

IMP_OBJECTS(ListPairContainer, ListPairContainers);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_LIST_PAIR_CONTAINER_H */
