/**
 *  \file IMP/container/ListQuadContainer.h
 *  \brief Store a list of kernel::ParticleQuadsTemp
 *
 *  WARNING This file was generated from ListQuadContainer.h
 *  in /builddir/build/BUILD/imp-2.3.0/imp/tools/build/container_templates/container
 *  by tools/build/make_containers.py.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_LIST_QUAD_CONTAINER_H
#define IMPCONTAINER_LIST_QUAD_CONTAINER_H

#include <IMP/container/container_config.h>
#include <IMP/base/object_macros.h>
#include <IMP/kernel/internal/StaticListContainer.h>
#include <IMP/kernel/QuadContainer.h>
#include <IMP/kernel/QuadModifier.h>
#include <IMP/kernel/base_types.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Store a kernel::ParticleIndexQuads
/** \note The order may change when particles are inserted
    as the list is maintained in sorted order.

    \note Changing the contents of the container is a fairly heavy
    weight operation as it resets part of the dependency graph. Use
    a DynamicListQuadContainer if you want to change the contents
    frequently (eg via a kernel::ScoreState).
 */
class IMPCONTAINEREXPORT ListQuadContainer :
#if defined(IMP_DOXYGEN) || defined(SWIG)
    public QuadContainer
#else
    public IMP::kernel::internal::StaticListContainer<
        kernel::QuadContainer>
#endif
    {
  typedef IMP::kernel::internal::StaticListContainer<kernel::QuadContainer>
      P;

 public:
  ListQuadContainer(kernel::Model *m, const kernel::ParticleIndexQuads &contents,
                         std::string name = "ListQuadContainer%1%");

  ListQuadContainer(const kernel::ParticleQuadsTemp &ps,
                         std::string name = "ListQuadContainer%1%");

  void set_particle_quads(const kernel::ParticleQuadsTemp &ps);
  void set_particle_quads(const kernel::ParticleIndexQuads &contents);
#ifndef IMP_DOXYGEN
  ListQuadContainer(kernel::Model *m,
                         std::string name = "ListQuadContainer %1%");
  ListQuadContainer(kernel::Model *m, const char *name);

  void add_particle_quad(const kernel::ParticleQuad& vt);
  void add_particle_quads(const kernel::ParticleQuadsTemp &c);
  void clear_particle_quads();
#endif
#ifdef SWIG
  kernel::ParticleIndexQuads get_indexes() const;
  kernel::ParticleIndexQuads get_range_indexes() const;
  kernel::ModelObjectsTemp do_get_inputs() const;
  void do_apply(const QuadModifier *sm) const;
  kernel::ParticleIndexes get_all_possible_indexes() const;

 private:
  std::size_t do_get_contents_hash() const;
#endif
  IMP_OBJECT_METHODS(ListQuadContainer);
};

IMP_OBJECTS(ListQuadContainer, ListQuadContainers);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_LIST_QUAD_CONTAINER_H */
