/**
 *  \file IMP/container/ListSingletonContainer.h
 *  \brief Store a list of kernel::ParticlesTemp
 *
 *  WARNING This file was generated from ListSingletonContainer.h
 *  in /builddir/build/BUILD/imp-2.3.0/imp/tools/build/container_templates/container
 *  by tools/build/make_containers.py.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_LIST_SINGLETON_CONTAINER_H
#define IMPCONTAINER_LIST_SINGLETON_CONTAINER_H

#include <IMP/container/container_config.h>
#include <IMP/base/object_macros.h>
#include <IMP/kernel/internal/StaticListContainer.h>
#include <IMP/kernel/SingletonContainer.h>
#include <IMP/kernel/SingletonModifier.h>
#include <IMP/kernel/base_types.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Store a kernel::ParticleIndexes
/** \note The order may change when particles are inserted
    as the list is maintained in sorted order.

    \note Changing the contents of the container is a fairly heavy
    weight operation as it resets part of the dependency graph. Use
    a DynamicListSingletonContainer if you want to change the contents
    frequently (eg via a kernel::ScoreState).
 */
class IMPCONTAINEREXPORT ListSingletonContainer :
#if defined(IMP_DOXYGEN) || defined(SWIG)
    public SingletonContainer
#else
    public IMP::kernel::internal::StaticListContainer<
        kernel::SingletonContainer>
#endif
    {
  typedef IMP::kernel::internal::StaticListContainer<kernel::SingletonContainer>
      P;

 public:
  ListSingletonContainer(kernel::Model *m, const kernel::ParticleIndexes &contents,
                         std::string name = "ListSingletonContainer%1%");

  ListSingletonContainer(const kernel::ParticlesTemp &ps,
                         std::string name = "ListSingletonContainer%1%");

  void set_particles(const kernel::ParticlesTemp &ps);
  void set_particles(const kernel::ParticleIndexes &contents);
#ifndef IMP_DOXYGEN
  ListSingletonContainer(kernel::Model *m,
                         std::string name = "ListSingletonContainer %1%");
  ListSingletonContainer(kernel::Model *m, const char *name);

  void add_particle(kernel::Particle* vt);
  void add_particles(const kernel::ParticlesTemp &c);
  void clear_particles();
#endif
#ifdef SWIG
  kernel::ParticleIndexes get_indexes() const;
  kernel::ParticleIndexes get_range_indexes() const;
  kernel::ModelObjectsTemp do_get_inputs() const;
  void do_apply(const SingletonModifier *sm) const;
  kernel::ParticleIndexes get_all_possible_indexes() const;

 private:
  std::size_t do_get_contents_hash() const;
#endif
  IMP_OBJECT_METHODS(ListSingletonContainer);
};

IMP_OBJECTS(ListSingletonContainer, ListSingletonContainers);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_LIST_SINGLETON_CONTAINER_H */
