/**
 *  \file IMP/container/MinimumPairScore.h
 *  \brief Define PairScore.
 *
 *  This file is generated by a script (tools/make-container).
 *  Do not edit directly.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_MINIMUM_PAIR_SCORE_H
#define IMPCONTAINER_MINIMUM_PAIR_SCORE_H

#include <IMP/container/container_config.h>
#include <IMP/PairScore.h>
#include <IMP/pair_macros.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Evaluate the min or max n particle_pair scores of the passed set
/** Each of the set of PairScores is evaluated and the sum of the
    minimum n is returned.
*/
class IMPCONTAINEREXPORT MinimumPairScore : public PairScore {
  PairScores scores_;
  unsigned int n_;

 public:
  MinimumPairScore(const PairScoresTemp &scores, unsigned int n = 1,
                        std::string name = "PairScore %1%");
  virtual double evaluate_index(kernel::Model *m, const kernel::ParticleIndexPair& vt,
                                DerivativeAccumulator *da) const IMP_OVERRIDE;
  virtual kernel::ModelObjectsTemp do_get_inputs(
      kernel::Model *m, const kernel::ParticleIndexes &pis) const IMP_OVERRIDE;
  IMP_PAIR_SCORE_METHODS(MinimumPairScore);
  IMP_OBJECT_METHODS(MinimumPairScore);

  Restraints do_create_current_decomposition(kernel::Model *m,
                                             const kernel::ParticleIndexPair& vt) const
      IMP_OVERRIDE;
};

IMP_OBJECTS(MinimumPairScore, MinimumPairScores);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_MINIMUM_PAIR_SCORE_H */
