/**
 *  \file IMP/container/MinimumSingletonScore.h
 *  \brief Define SingletonScore.
 *
 *  This file is generated by a script (tools/make-container).
 *  Do not edit directly.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_MINIMUM_SINGLETON_SCORE_H
#define IMPCONTAINER_MINIMUM_SINGLETON_SCORE_H

#include <IMP/container/container_config.h>
#include <IMP/SingletonScore.h>
#include <IMP/singleton_macros.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Evaluate the min or max n particle scores of the passed set
/** Each of the set of SingletonScores is evaluated and the sum of the
    minimum n is returned.
*/
class IMPCONTAINEREXPORT MinimumSingletonScore : public SingletonScore {
  SingletonScores scores_;
  unsigned int n_;

 public:
  MinimumSingletonScore(const SingletonScoresTemp &scores, unsigned int n = 1,
                        std::string name = "SingletonScore %1%");
  virtual double evaluate_index(kernel::Model *m, kernel::ParticleIndex vt,
                                DerivativeAccumulator *da) const IMP_OVERRIDE;
  virtual kernel::ModelObjectsTemp do_get_inputs(
      kernel::Model *m, const kernel::ParticleIndexes &pis) const IMP_OVERRIDE;
  IMP_SINGLETON_SCORE_METHODS(MinimumSingletonScore);
  IMP_OBJECT_METHODS(MinimumSingletonScore);

  Restraints do_create_current_decomposition(kernel::Model *m,
                                             kernel::ParticleIndex vt) const
      IMP_OVERRIDE;
};

IMP_OBJECTS(MinimumSingletonScore, MinimumSingletonScores);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_MINIMUM_SINGLETON_SCORE_H */
