/**
 *  \file IMP/core/QuadRestraint.h
 *  \brief Apply a QuadScore to a Quad.
 *
 *  WARNING This file was generated from QuadRestraint.h
 *  in /builddir/build/BUILD/imp-2.3.0/imp/tools/build/container_templates/core
 *  by tools/build/make_containers.py.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 *
 */

#ifndef IMPCORE_QUAD_RESTRAINT_H
#define IMPCORE_QUAD_RESTRAINT_H

#include <IMP/core/core_config.h>

#include <IMP/kernel/internal/TupleRestraint.h>
#include <IMP/QuadScore.h>

#include <iostream>

IMPCORE_BEGIN_NAMESPACE

//! Applies a QuadScore to a Quad.
/** This restraint stores a Quad.
    \see QuadRestraint
 */
class QuadRestraint :
#if defined(SWIG) || defined(IMP_DOXYGEN)
    public Restraint
#else
    public IMP::kernel::internal::TupleRestraint<QuadScore>
#endif
    {
 public:
  //! Create the restraint.
  /** This function takes the function to apply to the
      stored Quad and the Quad.
   */
  QuadRestraint(QuadScore *ss, const kernel::ParticleQuad& vt,
                     std::string name = "QuadRestraint %1%")
      : IMP::kernel::internal::TupleRestraint<QuadScore>(
            ss, IMP::kernel::internal::get_model(vt),
            IMP::kernel::internal::get_index(vt), name) {}

  //! Create the restraint.
  /** This function takes the function to apply to the
      stored Quad and the Quad.
   */
  QuadRestraint(kernel::Model *m, QuadScore *ss, const kernel::ParticleIndexQuad& vt,
                     std::string name = "QuadRestraint %1%")
      : IMP::kernel::internal::TupleRestraint<QuadScore>(ss, m, vt, name) {
  }

#if defined(SWIG) || defined(IMP_DOXYGEN)
 protected:
  double unprotected_evaluate(IMP::DerivativeAccumulator *accum) const;
  IMP::kernel::ModelObjectsTemp do_get_inputs() const;
  IMP_OBJECT_METHODS(QuadRestraint)
#endif
};

IMPCORE_END_NAMESPACE

#endif /* IMPCORE_QUAD_RESTRAINT_H */
