/**
 *  \file IMP/core/SingletonRestraint.h
 *  \brief Apply a SingletonScore to a Singleton.
 *
 *  WARNING This file was generated from SingletonRestraint.h
 *  in /builddir/build/BUILD/imp-2.3.0/imp/tools/build/container_templates/core
 *  by tools/build/make_containers.py.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 *
 */

#ifndef IMPCORE_SINGLETON_RESTRAINT_H
#define IMPCORE_SINGLETON_RESTRAINT_H

#include <IMP/core/core_config.h>

#include <IMP/kernel/internal/TupleRestraint.h>
#include <IMP/SingletonScore.h>

#include <iostream>

IMPCORE_BEGIN_NAMESPACE

//! Applies a SingletonScore to a Singleton.
/** This restraint stores a Singleton.
    \see SingletonRestraint
 */
class SingletonRestraint :
#if defined(SWIG) || defined(IMP_DOXYGEN)
    public Restraint
#else
    public IMP::kernel::internal::TupleRestraint<SingletonScore>
#endif
    {
 public:
  //! Create the restraint.
  /** This function takes the function to apply to the
      stored Singleton and the Singleton.
   */
  SingletonRestraint(SingletonScore *ss, kernel::Particle* vt,
                     std::string name = "SingletonRestraint %1%")
      : IMP::kernel::internal::TupleRestraint<SingletonScore>(
            ss, IMP::kernel::internal::get_model(vt),
            IMP::kernel::internal::get_index(vt), name) {}

  //! Create the restraint.
  /** This function takes the function to apply to the
      stored Singleton and the Singleton.
   */
  SingletonRestraint(kernel::Model *m, SingletonScore *ss, kernel::ParticleIndex vt,
                     std::string name = "SingletonRestraint %1%")
      : IMP::kernel::internal::TupleRestraint<SingletonScore>(ss, m, vt, name) {
  }

#if defined(SWIG) || defined(IMP_DOXYGEN)
 protected:
  double unprotected_evaluate(IMP::DerivativeAccumulator *accum) const;
  IMP::kernel::ModelObjectsTemp do_get_inputs() const;
  IMP_OBJECT_METHODS(SingletonRestraint)
#endif
};

IMPCORE_END_NAMESPACE

#endif /* IMPCORE_SINGLETON_RESTRAINT_H */
