/**
 *  \file IMP/kernel.h
 *  \brief Include all non-deprecated headers in IMP.kernel.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 */

#ifndef IMP_KERNEL_H
#define IMP_KERNEL_H
#include <IMP/kernel/AttributeOptimizer.h>
#include <IMP/kernel/Configuration.h>
#include <IMP/kernel/ConfigurationSet.h>
#include <IMP/kernel/Constraint.h>
#include <IMP/kernel/Decorator.h>
#include <IMP/kernel/DerivativeAccumulator.h>
#include <IMP/kernel/FloatIndex.h>
#include <IMP/kernel/Key.h>
#include <IMP/kernel/Model.h>
#include <IMP/kernel/ModelObject.h>
#include <IMP/kernel/Optimizer.h>
#include <IMP/kernel/OptimizerState.h>
#include <IMP/kernel/Particle.h>
#include <IMP/kernel/ParticleTuple.h>
#include <IMP/kernel/Refiner.h>
#include <IMP/kernel/Restraint.h>
#include <IMP/kernel/RestraintSet.h>
#include <IMP/kernel/Sampler.h>
#include <IMP/kernel/ScoreAccumulator.h>
#include <IMP/kernel/ScoreState.h>
#include <IMP/kernel/ScoringFunction.h>
#include <IMP/kernel/UnaryFunction.h>
#include <IMP/kernel/Undecorator.h>
#include <IMP/kernel/base_types.h>
#include <IMP/kernel/constants.h>
#include <IMP/kernel/container_base.h>
#include <IMP/kernel/container_macros.h>
#include <IMP/kernel/decorator_macros.h>
#include <IMP/kernel/dependency_graph.h>
#include <IMP/kernel/doxygen.h>
#include <IMP/kernel/functor.h>
#include <IMP/kernel/generic.h>
#include <IMP/kernel/input_output.h>
#include <IMP/kernel/io.h>
#include <IMP/kernel/macros.h>
#include <IMP/kernel/model_object_helpers.h>
#include <IMP/kernel/particle_index.h>
#include <IMP/kernel/python_only.h>
#include <IMP/kernel/scoped.h>
#include <IMP/kernel/utility.h>
#include <IMP/kernel/SingletonContainer.h>
#include <IMP/kernel/SingletonDerivativeModifier.h>
#include <IMP/kernel/SingletonModifier.h>
#include <IMP/kernel/SingletonPredicate.h>
#include <IMP/kernel/SingletonScore.h>
#include <IMP/kernel/singleton_macros.h>
#include <IMP/kernel/PairContainer.h>
#include <IMP/kernel/PairDerivativeModifier.h>
#include <IMP/kernel/PairModifier.h>
#include <IMP/kernel/PairPredicate.h>
#include <IMP/kernel/PairScore.h>
#include <IMP/kernel/pair_macros.h>
#include <IMP/kernel/TripletContainer.h>
#include <IMP/kernel/TripletDerivativeModifier.h>
#include <IMP/kernel/TripletModifier.h>
#include <IMP/kernel/TripletPredicate.h>
#include <IMP/kernel/TripletScore.h>
#include <IMP/kernel/triplet_macros.h>
#include <IMP/kernel/QuadContainer.h>
#include <IMP/kernel/QuadDerivativeModifier.h>
#include <IMP/kernel/QuadModifier.h>
#include <IMP/kernel/QuadPredicate.h>
#include <IMP/kernel/QuadScore.h>
#include <IMP/kernel/quad_macros.h>
#endif /* IMP_KERNEL_H */