/**
 *  \file IMP/kernel/QuadModifier.h
 *  \brief A Modifier on kernel::ParticleQuadsTemp
 *
 *  WARNING This file was generated from QuadModifier.h
 *  in /builddir/build/BUILD/imp-2.3.0/imp/tools/build/container_templates/kernel
 *  by tools/build/make_containers.py.
 *
 *  Copyright 2007-2014 IMP Inventors. All rights reserved.
 */

#ifndef IMPKERNEL_QUAD_MODIFIER_H
#define IMPKERNEL_QUAD_MODIFIER_H

#include <IMP/kernel/kernel_config.h>
#include "DerivativeAccumulator.h"
#include "base_types.h"
#include "ParticleTuple.h"
#include "internal/container_helpers.h"
#include "model_object_helpers.h"

IMPKERNEL_BEGIN_NAMESPACE

//! A base class for modifiers of kernel::ParticleQuadsTemp
/** The primary function of such a class is to change
    the passed particles.

    \see IMP::QuadFunctor

    Implementors should see IMP_QUAD_MODIFIER(). Also see
    QuadDerivativeModifier.
 */
class IMPKERNELEXPORT QuadModifier : public ParticleInputs,
                                          public ParticleOutputs,
                                          public base::Object {
 public:
  typedef kernel::ParticleQuad Argument;
  typedef kernel::ParticleIndexQuad IndexArgument;
  QuadModifier(std::string name = "QuadModifier %1%");

  /** \deprecated_at{2.1} use the index version instead*/
  IMPKERNEL_DEPRECATED_METHOD_DECL(2.1)
  virtual void apply(const kernel::ParticleQuad& vt) const;

  /** Apply the function to a single value*/
  virtual void apply_index(kernel::Model *m, const kernel::ParticleIndexQuad& v) const;

  /** Apply the function to a collection of kernel::ParticleQuadsTemp */
  /** If bounds are passed, only apply to ones between the upper and
      lower bounds.*/
  virtual void apply_indexes(kernel::Model *m, const kernel::ParticleIndexQuads &o,
                             unsigned int lower_bound,
                             unsigned int upper_bound) const {
    for (unsigned int i = lower_bound; i < upper_bound; ++i) {
      apply_index(m, o[i]);
    }
  }
};

IMPKERNEL_END_NAMESPACE

#endif /* IMPKERNEL_QUAD_MODIFIER_H */
